#===============================================================================
# Copyright 2014-2017 Intel Corporation All Rights Reserved.
#
# The source code,  information  and material  ("Material") contained  herein is
# owned by Intel Corporation or its  suppliers or licensors,  and  title to such
# Material remains with Intel  Corporation or its  suppliers or  licensors.  The
# Material  contains  proprietary  information  of  Intel or  its suppliers  and
# licensors.  The Material is protected by  worldwide copyright  laws and treaty
# provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
# modified, published,  uploaded, posted, transmitted,  distributed or disclosed
# in any way without Intel's prior express written permission.  No license under
# any patent,  copyright or other  intellectual property rights  in the Material
# is granted to  or  conferred  upon  you,  either   expressly,  by implication,
# inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
# property rights must be express and approved by Intel in writing.
#
# Unless otherwise agreed by Intel in writing,  you may not remove or alter this
# notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
# suppliers or licensors in any way.
#===============================================================================

## <a name="DAAL-EXAMPLE-PY-APRIORI_BATCH"></a>
## \example assoc_rules_apriori_batch.py

from os.path import join as jp
from daal.data_management import FileDataSource, DataSourceIface
from daal.algorithms.association_rules import (
    Batch_Float64Apriori, data, largeItemsets, largeItemsetsSupport,
    antecedentItemsets, consequentItemsets, confidence
)
import inspect, sys, os.path
utils_folder = os.path.realpath(os.path.abspath(jp(os.path.split(inspect.getfile(inspect.currentframe()))[0], "..")))
if utils_folder not in sys.path:
    sys.path.insert(0, utils_folder)
from utils import printAprioriItemsets, printAprioriRules

#  Input data set parameters
datasetFileName = os.path.join('..','data','batch','apriori.csv')

#  Apriori algorithm parameters
minSupport = 0.001
minConfidence = 0.7

#  Initialize FileDataSource_CSVFeatureManager to retrieve the input data from a .csv file
dataSource = FileDataSource(
    datasetFileName, DataSourceIface.doAllocateNumericTable, DataSourceIface.doDictionaryFromContext
)

#  Retrieve the data from the input file
dataSource.loadDataBlock()

#  Create an algorithm to mine association rules using the Apriori method
alg = Batch_Float64Apriori()
alg.input.set(data, dataSource.getNumericTable())
alg.parameter.minSupport = minSupport
alg.parameter.minConfidence = minConfidence

#  Find large item sets and construct association rules
res = alg.compute()

#  Get computed results of the Apriori algorithm
nt1 = res.get(largeItemsets)
nt2 = res.get(largeItemsetsSupport)

nt3 = res.get(antecedentItemsets)
nt4 = res.get(consequentItemsets)
nt5 = res.get(confidence)

printAprioriItemsets(nt1, nt2)
printAprioriRules(nt3, nt4, nt5)
